; Moschino's profile manager designed to work with only the Moschino[FlashBuzzen] connection.
; -
; Please visit http://moschino.org.uk for updates/problems/suggesstions.
; Thanks, Dabba.


on *:START: {
  if ($Con_Version < 2.37) {
    echo -sace info *** Moschino[ProfileManager] will only work correctly on connection version 2.37 (onwards). $&
      Please update your Moschino[FlashBuzzen] connection.
  }

  if (!$Item_Exists(PROFILE, SCAN_PROFILES)) MainSettings PROFILE SCAN_PROFILES 1
  if (!$Item_Exists(PROFILE, ECHO)) MainSettings PROFILE ECHO 0
  if (!$Item_Exists(PROFILE, MSG)) MainSettings PROFILE MSG 1
  if (!$Item_Exists(PROFILE, SHOW_NAME)) MainSettings PROFILE SHOW_NAME 1
  if (!$Item_Exists(PROFILE, SHOW_LOCATION)) MainSettings PROFILE SHOW_LOCATION 1
  if (!$Item_Exists(PROFILE, SHOW_AGE)) MainSettings PROFILE SHOW_AGE 1
  if (!$Item_Exists(PROFILE, SHOW_GENDER)) MainSettings PROFILE SHOW_GENDER 1
  if (!$Item_Exists(PROFILE, SHOW_MARITAL_STATUS)) MainSettings PROFILE SHOW_MARITAL_STATUS 1
  if (!$Item_Exists(PROFILE, SHOW_HOMEPAGE)) MainSettings PROFILE SHOW_HOMEPAGE 1
  if (!$Item_Exists(PROFILE, SHOW_EMAIL)) MainSettings PROFILE SHOW_EMAIL 1
  if (!$Item_Exists(PROFILE, SHOW_URL)) MainSettings PROFILE SHOW_URL 1
  if (!$Item_Exists(PROFILE, KICK_UNDERAGE_USERS)) MainSettings PROFILE KICK_UNDERAGE_USERS 0
  if (!$Item_Exists(PROFILE, UNDER_AGE)) MainSettings PROFILE UNDER_AGE 18
  if (!$Item_Exists(PROFILE, UNDER_AGE_MSG)) MainSettings PROFILE UNDER_AGE_MSG Underage twat! Limit here is 18!
  if (!$Item_Exists(PROFILE, KICK_UNDISCLOSED_AGE)) MainSettings PROFILE KICK_UNDISCLOSED_AGE 0
  if (!$Item_Exists(PROFILE, UNDISCLOSED_AGE_MSG)) MainSettings PROFILE UNDISCLOSED_AGE_MSG $(%Nick $+ ! Your age is undisclosed! :@, )
  if (!$Item_Exists(PROFILE, KICK_UNDISCLOSED_NAME)) MainSettings PROFILE KICK_UNDISCLOSED_NAME 0
  if (!$Item_Exists(PROFILE, UNDISCLOSED_NAME_MSG)) MainSettings PROFILE UNDISCLOSED_NAME_MSG $(You have an undisclosed name, %Nick $+ . Bye., )
  if (!$Item_Exists(PROFILE, KICK_UNDISCLOSED_LOCATION)) MainSettings PROFILE KICK_UNDISCLOSED_LOCATION 0
  if (!$Item_Exists(PROFILE, UNDISCLOSED_LOCATION_MSG)) MainSettings PROFILE UNDISCLOSED_LOCATION_MSG $(You have no location set! Go back and do it %Nick $+ !, )
  if (!$Item_Exists(PROFILE, KICK_UNDISCLOSED_GENDER)) MainSettings PROFILE KICK_UNDISCLOSED_GENDER 0
  if (!$Item_Exists(PROFILE, UNDISCLOSED_GENDER_MSG)) MainSettings PROFILE UNDISCLOSED_GENDER_MSG You have no gender set dumbass.
  if (!$Item_Exists(PROFILE, KICK_MALES)) MainSettings PROFILE KICK_MALES 0
  if (!$Item_Exists(PROFILE, KICK_MALES_MSG)) MainSettings PROFILE KICK_MALES_MSG No males allowed in this room!
  if (!$Item_Exists(PROFILE, KICK_FEMALES)) MainSettings PROFILE KICK_FEMALES 0
  if (!$Item_Exists(PROFILE, KICK_FEMALES_MSG)) MainSettings PROFILE KICK_FEMALES_MSG Grr, no damn girls allowed in here!
  if (!$Item_Exists(PROFILE, KICK_NO_IMAGE)) MainSettings PROFILE KICK_NO_IMAGE 0
  if (!$Item_Exists(PROFILE, NO_IMAGE_MSG)) MainSettings PROFILE NO_IMAGE_MSG You have no image in your profile, please add one.
  if (!$Item_Exists(PROFILE, HALT_OPS)) MainSettings PROFILE HALT_OPS 1
  if (!$Item_Exists(PROFILE, BAN_USERS)) MainSettings PROFILE BAN_USERS 1
  if (!$Item_Exists(PROFILE, BAN_DURATION)) MainSettings PROFILE BAN_DURATION 6
  if (!$Item_Exists(PROFILE, PERMANENT_BAN)) MainSettings PROFILE PERMANENT_BAN 0
  if (!$Item_Exists(PROFILE, CLEAR_OWNER_HOST)) MainSettings PROFILE CLEAR_OWNER_HOST 0
}

dialog ProfileManager {
  title Moschino[ProfileManager]1.3
  size -1 -1 199 292
  option dbu
}

on *:DIALOG:ProfileManager:INIT:0:{
  var %D = $Dname

  dcx Mark %D ProfileManager_Callback

  ; Border.
  xdialog -b %D +woty

  ; Listview control.
  xdialog -c %D 1 listview 1 2 197 250 report grid borderselect flatsb fullrow
  xdid -t %D 1 +l 0 193 Users (right-click users)
  xdid -l %D 1 16 1 0 0
  xdid -w %D 1 +n 0 $MircdirIcons/staff.ico
  xdid -w %D 1 +n 0 $MircdirIcons/superowner.ico
  xdid -w %D 1 +n 0 $MircdirIcons/owner.ico
  xdid -w %D 1 +n 0 $MircdirIcons/host.ico
  xdid -w %D 1 +n 0 $MircdirIcons/helpop.ico

  ; Listview control.
  xdialog -c %D 2 listview 200 2 197 124 report grid borderselect flatsb fullrow
  xdid -t %D 2 +l 0 593 Profile capture (right-click entries)

  ; Check boxes.
  xdialog -c %D 3 check 200 127 164 16
  xdialog -c %D 4 check 200 143 80 16
  xdialog -c %D 5 check 290 143 100 16
  xdid -t %D 3 Scan profiles onjoin
  xdid -t %D 4 Echo profiles
  xdid -t %D 5 Msg profiles
  if ($MainSettings(PROFILE, SCAN_PROFILES) == 1) xdid -c %D 3
  if ($MainSettings(PROFILE, ECHO) == 1) xdid -c %D 4
  if ($MainSettings(PROFILE, MSG) == 1) xdid -c %D 5

  ; Text control.
  xdialog -c %D 7365 text 200 173 196 15
  xdid -t %D 7365 Profile echos and messages
  xdid -f %D 7365 +u ansi 8 Tahoma

  xdialog -c %D 283 check 200 190 80 16
  xdialog -c %D 284 check 200 206 83 16
  xdialog -c %D 285 check 200 222 80 16
  xdialog -c %D 286 check 286 190 100 16
  xdialog -c %D 287 check 286 206 113 16
  xdialog -c %D 288 check 286 222 100 16
  xdialog -c %D 289 check 200 238 80 16
  xdialog -c %D 290 check 286 238 100 16
  xdid -t %D 283 Show name
  xdid -t %D 284 Show location
  xdid -t %D 285 Show age
  xdid -t %D 286 Show gender
  xdid -t %D 287 Show marital status
  xdid -t %D 288 Show homepage
  xdid -t %D 289 Show email
  xdid -t %D 290 Show profile url

  if ($MainSettings(PROFILE, SHOW_NAME) == 1) xdid -c %D 283
  if ($MainSettings(PROFILE, SHOW_LOCATION) == 1) xdid -c %D 284
  if ($MainSettings(PROFILE, SHOW_AGE) == 1) xdid -c %D 285
  if ($MainSettings(PROFILE, SHOW_GENDER) == 1) xdid -c %D 286
  if ($MainSettings(PROFILE, SHOW_MARITAL_STATUS) == 1) xdid -c %D 287
  if ($MainSettings(PROFILE, SHOW_HOMEPAGE) == 1) xdid -c %D 288
  if ($MainSettings(PROFILE, SHOW_EMAIL) == 1) xdid -c %D 289
  if ($MainSettings(PROFILE, SHOW_URL) == 1) xdid -c %D 290

  ; Box control.
  xdialog -c %D 6 box 2 254 395 183
  xdid -t %D 6 Profile kicks

  xdid -c %D 6 7 check 7 20 110 15
  xdid -t %D 7 Users under age
  xdid -c %D 6 8 edit 130 18 31 19 autohs
  xdid -a %D 8 $MainSettings(PROFILE, UNDER_AGE)
  xdid -c %D 6 874 edit 162 18 228 19 autohs
  xdid -a %D 874 $MainSettings(PROFILE, UNDER_AGE_MSG)
  if ($MainSettings(PROFILE, KICK_UNDERAGE_USERS) == 1) xdid -c %D 7
  if ($MainSettings(PROFILE, KICK_UNDERAGE_USERS) == 0) xdid -b %D 8,874

  xdid -c %D 6 9 check 7 40 110 15
  xdid -t %D 9 Undisclosed age
  xdid -c %D 6 10 edit 130 38 260 19 autohs
  xdid -a %D 10 $Readini(data/GlobalSettings.ini, n, PROFILE, UNDISCLOSED_AGE_MSG))
  if ($MainSettings(PROFILE, KICK_UNDISCLOSED_AGE) == 1) xdid -c %D 9
  if ($MainSettings(PROFILE, KICK_UNDISCLOSED_AGE) == 0) xdid -b %D 10

  xdid -c %D 6 11 check 7 60 110 15
  xdid -t %D 11 Undisclosed name
  xdid -c %D 6 12 edit 130 58 260 19 autohs
  xdid -a %D 12 $Readini($Fp(data/GlobalSettings.ini), n, PROFILE, UNDISCLOSED_NAME_MSG)
  if ($MainSettings(PROFILE, KICK_UNDISCLOSED_NAME) == 1) xdid -c %D 11
  if ($MainSettings(PROFILE, KICK_UNDISCLOSED_NAME) == 0) xdid -b %D 12

  xdid -c %D 6 73 check 7 80 115 15
  xdid -t %D 73 Undisclosed location
  xdid -c %D 6 74 edit 130 78 260 19 autohs
  xdid -a %D 74 $Readini($Fp(data/GlobalSettings.ini), n, PROFILE, UNDISCLOSED_LOCATION_MSG))
  if ($MainSettings(PROFILE, KICK_UNDISCLOSED_LOCATION) == 1) xdid -c %D 73
  if ($MainSettings(PROFILE, KICK_UNDISCLOSED_LOCATION) == 0) xdid -b %D 74

  xdid -c %D 6 13 check 7 100 110 15
  xdid -t %D 13 Undisclosed gender
  xdid -c %D 6 14 edit 130 98 260 19 autohs
  xdid -a %D 14 $Readini($Fp(data/GlobalSettings.ini), n, PROFILE, UNDISCLOSED_GENDER_MSG))
  if ($MainSettings(PROFILE, KICK_UNDISCLOSED_GENDER) == 1) xdid -c %D 13
  if ($MainSettings(PROFILE, KICK_UNDISCLOSED_GENDER) == 0) xdid -b %D 14

  xdid -c %D 6 15 check 7 120 110 15
  xdid -t %D 15 Kick males
  xdid -c %D 6 16 edit 130 118 260 19 autohs
  xdid -a %D 16 $Readini($Fp(data/GlobalSettings.ini), n, PROFILE, KICK_MALES_MSG))
  if ($MainSettings(PROFILE, KICK_MALES) == 1) xdid -c %D 15
  if ($MainSettings(PROFILE, KICK_MALES) == 0) xdid -b %D 16

  xdid -c %D 6 17 check 7 140 110 15
  xdid -t %D 17 Kick females
  xdid -c %D 6 18 edit 130 138 260 19 autohs
  xdid -a %D 18 $Readini($Fp(data/GlobalSettings.ini), n, PROFILE, KICK_FEMALES_MSG))
  if ($MainSettings(PROFILE, KICK_FEMALES) == 1) xdid -c %D 17
  if ($MainSettings(PROFILE, KICK_FEMALES) == 0) xdid -b %D 18

  xdid -c %D 6 119 check 7 160 110 15
  xdid -t %D 119 No profile pic
  xdid -c %D 6 210 edit 130 158 260 19 autohs
  xdid -a %D 210 $Readini($Fp(data/GlobalSettings.ini), n, PROFILE, NO_IMAGE_MSG))
  if ($MainSettings(PROFILE, KICK_NO_IMAGE) == 1) xdid -c %D 119
  if ($MainSettings(PROFILE, KICK_NO_IMAGE) == 0) xdid -b %D 210


  ; Box control.
  xdialog -c %D 7364 box 2 441 395 114
  xdid -t %D 7364 Kick options (channel halts will halt profile kicks and messages)

  xdid -c %D 7364 35 check 6 18 165 15
  xdid -t %D 35 Halt kicks on owners/hosts
  if ($MainSettings(PROFILE, HALT_OPS) == 1) xdid -c %D 35
  xdid -c %D 7364 135 check 180 18 205 15
  xdid -t %D 135 Clear owner/host access before kick
  if ($MainSettings(PROFILE, CLEAR_OWNER_HOST) == 1) xdid -c %D 135
  xdid -c %D 7364 36 check 6 38 83 15
  xdid -t %D 36 Ban users for
  if ($MainSettings(PROFILE, BAN_USERS) == 1) xdid -c %D 36
  xdid -c %D 7364 876 edit 92 35 40 22
  xdid -c %D 7364 866 updown 180 70 80 20 buddyint
  xdid -r %D 866 1 30
  xdid -c %D 866 876
  xdid -v %D 866 $MainSettings(PROFILE, BAN_DURATION)
  xdid -c %D 7364 896 text 136 38 40 18 
  xdid -t %D 896 (mins)
  if ($MainSettings(PROFILE, BAN_USERS) == 0) xdid -b %D 876

  xdid -c %D 7364 46 check 180 38 90 15
  xdid -t %D 46 Permanent ban
  if ($MainSettings(PROFILE, PERMANENT_BAN) == 1) xdid -c %D 46

  xdid -c %D 7364 736 comboex 6 60 289 138 dropdown

  var %x 1
  while (%x <= $Chan(0)) {
    xdid -a %D 736 0 0 0 0 0 $Chan(%x)

    inc %x
  }
  xdid -c %D 736 2

  xdid -c %D 7364 8458 button 298 60 92 22
  xdid -t %D 8458 Halt channel

  xdid -c %D 7364 263 text 7 90 80 22
  xdid -t %D 263 Halted channels:
  xdid -c %D 7364 921 comboex 91 85 204 138 dropdown
  xdid -c %D 7364 8468 button 298 85 92 22
  xdid -t %D 8468 Unhalt channel

  List_ProfileKicks_Halted_Channels

  xdialog -c %D 432443 text 401 3 150 16
  xdid -t %D 432443 Users profile image (if any):

  xdialog -c %D 4553 webctrl 399 19 400 542
  xdialog -c %D 4554 edit 399 563 399 21 center autohs

  ; Link.
  xdialog -c %D 19 text 3 565 135 23
  xdid -t %D 19 $MainSettings(CONNECTION, LINK)
  xdid -f %D 19 +au ansi 8 Verdana
  xdid -C %D 19 +t $Rgb(0, 0, 255)

  ; Button.
  xdialog -c %D 20 button 256 559 70 25
  xdid -l %D 20 16
  xdid -w %D 20 +n 0 $MircdirIcons/Settings.ico
  xdid -t %D 20 Ok

  ; Button.
  xdialog -c %D 44 button 332 559 30 25 
  xdid -l %D 44 16
  xdid -w %D 44 +n 0 $MircdirIcons/Forward.ico
  ;xdid -t %D 20 Ok

  ; Button.
  xdialog -c %D 45 button 366 559 30 25
  xdid -l %D 45 16
  xdid -w %D 45 +n 0 $MircdirIcons/user.ico
  ;xdid -t %D 20 Ok

  if ($MainSettings(PROFILE, SCAN_PROFILES) == 0) xdid -b %D 4,5,7,8,9,10,11,12,13,14,15,16,17,18,73,74,35,36,876,46,736,8458,921,8468,119,210

  ; Font.
  xdid -f %D 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,20,35,36,46,135,876,896,7364,73,74,736,8458,263,921,8468,283,284,285,286,287,288,289,290,874,4554,119,210,432443 +a ansi 8 Tahoma

  if ($Nick($Active, 0)) List_Nicks
}

; Do _NOT_ remove or edit this line. The version checker uses it.
alias ProfileManager_Version return 1.3

alias ProfileManager_Callback {
  ; echo -a $1-

  if ($2 == SCLICK) {
    ; echo -a $1-

    if ($3 == 19) RUN $xdid($1, 19).text

    elseif ($3 == 20) dialog -x $1

    elseif ($3 == 44) {
      dialog -s $1 -1 -1 399 -1
      xdid -b $1 44
      xdid -e $1 45
    }

    elseif ($3 == 45) {
      dialog -s $1 -1 -1 799 -1
      xdid -b $1 45
      xdid -e $1 44
    }

    elseif ($3 == 8458) {
      MainSettings PROFILEKICKS_HALTED $xdid($1, 736).seltext HALTED

      List_ProfileKicks_Halted_Channels
    }

    elseif ($3 == 8468) {
      RemSettings PROFILEKICKS_HALTED $xdid($1, 921).seltext

      List_ProfileKicks_Halted_Channels
    }
  }

  elseif ($2 == LBDOWN) {
    ; echo -a $1-

    if ($3 == 3) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE SCAN_PROFILES 1
        xdid -e $1 4,5,7,8,9,10,11,12,13,14,15,16,17,18,73,74,35,36,876,46,736,8458,921,8468,119,210
      }
      elseif (%State == 1) {
        MainSettings PROFILE SCAN_PROFILES 0
        xdid -b $1 4,5,7,8,9,10,11,12,13,14,15,16,17,18,73,74,35,36,876,46,736,8458,921,8468,119,210
      }
    }

    elseif ($3 == 4) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE ECHO $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 5) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE MSG $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 7) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE KICK_UNDERAGE_USERS 1
        xdid -e $1 8,874
      }
      elseif (%State == 1) {
        MainSettings PROFILE KICK_UNDERAGE_USERS 0
        xdid -b $1 8,874
      }
    }

    elseif ($3 == 9) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE KICK_UNDISCLOSED_AGE 1
        xdid -e $1 10
      }
      elseif (%State == 1) {
        MainSettings PROFILE KICK_UNDISCLOSED_AGE 0
        xdid -b $1 10
      }
    }

    elseif ($3 == 11) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE KICK_UNDISCLOSED_NAME 1
        xdid -e $1 12
      }
      elseif (%State == 1) {
        MainSettings PROFILE KICK_UNDISCLOSED_NAME 0
        xdid -b $1 12
      }
    }

    elseif ($3 == 13) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE KICK_UNDISCLOSED_GENDER 1
        xdid -e $1 14
      }
      elseif (%State == 1) {
        MainSettings PROFILE KICK_UNDISCLOSED_GENDER 0
        xdid -b $1 14
      }
    }

    elseif ($3 == 15) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE KICK_MALES 1
        xdid -e $1 16
      }
      elseif (%State == 1) {
        MainSettings PROFILE KICK_MALES 0
        xdid -b $1 16
      }
    }

    elseif ($3 == 17) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE KICK_FEMALES 1
        xdid -e $1 18
      }
      elseif (%State == 1) {
        MainSettings PROFILE KICK_FEMALES 0
        xdid -b $1 18
      }
    }

    elseif ($3 == 119) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE KICK_NO_IMAGE 1
        xdid -e $1 210
      }
      elseif (%State == 1) {
        MainSettings PROFILE KICK_NO_IMAGE 0
        xdid -b $1 210
      }
    }

    elseif ($3 == 73) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE KICK_UNDISCLOSED_LOCATION 1
        xdid -e $1 74
      }
      elseif (%State == 1) {
        MainSettings PROFILE KICK_UNDISCLOSED_LOCATION 0
        xdid -b $1 74
      }
    }

    elseif ($3 == 283) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_NAME $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 284) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_LOCATION $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 285) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_AGE $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 286) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_GENDER $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 287) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_MARITAL_STATUS $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 288) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_HOMEPAGE $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 289) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_EMAIL $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 290) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_URL $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 287) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE SHOW_MARITAL_STATUS $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 35) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE HALT_OPS $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 135) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE CLEAR_OWNER_HOST $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 36) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings PROFILE BAN_USERS 1
        xdid -e $1 876
      }

      elseif (%State == 1) {
        MainSettings PROFILE BAN_USERS 0
        xdid -b $1 876
      }
    }

    elseif ($3 == 46) {
      var %State = $xdid($1, $3).state

      MainSettings PROFILE PERMANENT_BAN $Iif(%State == 0, 1, 0)
    }
  }

  elseif ($2 == RCLICK) {
    if ($3 == 1) && ($4-) {
      var %Menu = PROFILE_LISTVIEW

      if ($xpopup(%Menu).ismenu) xpopup -d %Menu

      xpopup -c %Menu verticalrev 

      xpopup -p %Menu $Rgb(255, 255, 255) $Rgb(119, 136, 153) $Rgb(112, 128, 144) $&
        $Rgb(119, 136, 153) $Rgb(119, 136, 153) $Rgb(119, 136, 153) $&
        $Rgb(248, 248, 255)

      xpop -a %Menu 0 $Chr(9) +g 1 0 User: $xdid($1, 1, 1).seltext
      xpop -a %Menu 0 $Chr(9) + 2 0 -
      xpop -a %Menu 0 $Chr(9) + 3 0 Check $Gettok($xdid($1, 1, 1).seltext, 1, 32) $+ 's profile

      xpopup -s %Menu + $Mouse.dx $Mouse.dy
    }

    elseif ($3 == 2) && ($4-) {
      var %Menu = PROFILE_LISTVIEW2

      if ($xpopup(%Menu).ismenu) xpopup -d %Menu

      xpopup -c %Menu verticalrev 

      xpopup -p %Menu $Rgb(255, 255, 255) $Rgb(119, 136, 153) $Rgb(112, 128, 144) $&
        $Rgb(119, 136, 153) $Rgb(119, 136, 153) $Rgb(119, 136, 153) $&
        $Rgb(248, 248, 255)

      xpop -a %Menu 0 $Chr(9) + 1 0 Clipboard: $xdid($1, 2, 1).seltext

      xpopup -s %Menu + $Mouse.dx $Mouse.dy
    }
  }

  elseif ($2 == KEYUP) {
    var %File = $Fp(data\GlobalSettings.ini)

    if ($3 == 8) writeini -n %File PROFILE UNDER_AGE $xdid($1, 8).text
    elseif ($3 == 10) writeini -n %File PROFILE UNDISCLOSED_AGE_MSG $xdid($1, 10).text
    elseif ($3 == 12) writeini -n %File PROFILE UNDISCLOSED_NAME_MSG $xdid($1, 12).text
    elseif ($3 == 14) writeini -n %File PROFILE UNDISCLOSED_GENDER_MSG $xdid($1, 14).text
    elseif ($3 == 16) writeini -n %File PROFILE KICK_MALES_MSG $xdid($1, 16).text
    elseif ($3 == 18) writeini -n %File PROFILE KICK_FEMALES_MSG $xdid($1, 18).text
    elseif ($3 == 74) writeini -n %File PROFILE UNDISCLOSED_LOCATION_MSG $xdid($1, 74).text
    elseif ($3 == 874) writeini -n %File PROFILE UNDER_AGE_MSG $xdid($1, 874).text
  }

  elseif ($2 == MOUSE) {
    if ($3 == 866) || ($3 == 876) {
      MainSettings PROFILE BAN_DURATION $xdid($1, 866).value
    }
  }
}

alias List_ProfileKicks_Halted_Channels {
  var %File = $Fp(data/GlobalSettings.ini), %Section = PROFILEKICKS_HALTED, %x 1

  xdid -r ProfileManager 921

  while (%x <= $Ini(%File, %Section, 0)) {

    xdid -a ProfileManager 921 0 0 0 0 0 $Ini(%File, %Section, %x)

    inc %x
  }

  xdid -c ProfileManager 921 1
}

alias List_Nicks {
  var %x 1

  while (%x <= $Nick($Active, 0)) {
    var %Nick = $Nick($Active, %x), %Decoded = $Buzz.decode(%Nick), %Icon

    hadd -m PROFILE_D %Decoded %Nick

    var %Bracks

    if ($Nick($Active, %Nick, ^)) { %Bracks = Staff | %Icon = 1 } 
    elseif ($Nick($Active, %Nick, ')) { %Bracks = Superowner | %Icon = 2 }
    elseif ($Nick($Active, %Nick, .)) { %Bracks = Owner | %Icon = 3 }
    elseif ($Nick($Active, %Nick, @)) { %Bracks = Host | %Icon = 4 }
    elseif ($Nick($Active, %Nick, %)) { %Bracks = Helpop | %Icon = 5 }
    else { %Bracks = Regular | %Icon = 0 }

    xdid -a ProfileManager 1 0 0 + %Icon 0 0 0 0 0 %Decoded $RBracks(%Bracks)
    inc %x
  }

  .signal -n ROOM_NICKLIST_FINISHED
}

on *:SIGNAL:ROOM_NICKLIST_FINISHED: {
  if ($Dialog(ProfileManager)) xdid -z ProfileManager 1 +c 1 Sort_Alg
}

alias Listview_Profile {
  if ($Dialog(ProfileManager)) xdid -a ProfileManager 2 0 0 + 0 0 0 0 0 0 $$1-
}

alias Get_Profile {
  var %Nick = $$1, %PID = $$2, %Chan = $$3, %Sock = PROFILE.SCAN1. $+ $Numb(10)

  sockopen %Sock $MainSettings(CONNECTION, CHANLINK) 80
  sockmark %Sock %Nick %Chan %PID $Iif($4 == DIALOG_CHECK, DIALOG_CHECK, NORMAL)

  if ($4 == DIALOG_CHECK) && ($Dialog(ProfileManager)) {
    xdid -a ProfileManager 2 0 0 +b 0 0 0 0 0 0 User: $Buzz.decode(%Nick)
  }
}

alias Profile_Capture {
  tokenize 32 $1-

  if ($MainSettings(PROFILE, MSG) == 1) que 1000 msg $Chr(37) $!+ $Mid($3, 2) * Profile for $2 $7-
  if ($MainSettings(PROFILE, ECHO) == 1) echo -e $3 * Profile for $2 $7-
}

alias MultiProfileCheck {
  var %x 1, %Chan = $1, %Nicks = $2-, %Total = $Numtok(%Nicks, 32)

  if ($MainSettings(PROFILE, MSG) == 1) msg %Chan * Multi select nick profile check on: $Replace(%Nicks, $Chr(32), $+($Chr(44), $Chr(32))) $RBracks(%Total nick[s])
  if ($MainSettings(PROFILE, ECHO) == 1) echo -e %Chan * Multi select nick profile check on: $Replace(%Nicks, $Chr(32), $+($Chr(44), $Chr(32))) $RBracks(%Total nick[s])

  while (%x <= %Total) {
    var %Nick = $Gettok(%Nicks, %x, 32)

    hadd -m PROF_NORMAL_CHECK. $+ %Chan $+ %Nick %Nick %Nick
    que 500 sockwrite -n $C_Sock(%Chan) PID %Nick

    inc %x
  }
}

on ^!*:JOIN:#: { 
  if (!$Is_Guest($Nick)) && ($MainSettings(PROFILE, SCAN_PROFILES) == 1) && $&
    (!$MainSettings(PROFILEKICKS_HALTED, #)) && (*MCHAN* !iswm $Server) {

    hadd -m PROF_NORMAL_CHECK. $+ # $+ $Nick $Nick $Nick

    sockwrite -n $C_Sock(#) PID $Nick
  }
}

on *:SOCKOPEN:PROFILE.SCAN*: {
  if ($Sockerr) return

  tokenize 32 $Sock($Sockname).mark

  sockwrite -n $Sockname GET / $+ $Iif(*PROFILE.SCAN1* iswm $Sockname, profile.aspx?pid= $+ $3, $5-) HTTP/1.0 $+ $Crlf $+ $&
    Accept: */* $+ $Crlf $+ $&
    Accept-Language: EN-US $+ $CrLf $+ Accept-Encoding: gzip, deflate $+ $Crlf $+ $&
    User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1) $+ $Crlf $+ $&
    Host: $MainSettings(CONNECTION, WEBLINK) $+ $CrLf $+ $&
    Cookie: Cookie: lang=EN; $+ $Str($Crlf, 2)
}

on *:SOCKREAD:PROFILE.SCAN*: {
  if ($Sockerr > 0) return

  tokenize 32 $Sock($Sockname).mark

  var %Read, %Nick = $1, %Chan = $2, %Pid = $3

  sockread %Read

  if ($Regex(%Read, /Location: (.*)/)) {
    if (*PROFILE.SCAN1* iswm $Sockname) {
      var %Sock = PROFILE.SCAN2. $+ $Numb(10)

      sockopen %Sock $Gettok($Regml(1), 2, 47) 80
      sockmark %Sock %Nick %Chan %PID $Iif($4 == DIALOG_CHECK, DIALOG_CHECK, NORMAL) $Gettok($Regml(1), 3-, 47)
    }

    else {
      var %Sock = PROFILE.FINAL. $+ $Numb(10)

      sockopen %Sock $MainSettings(CONNECTION, WEBLINK) 80
      sockmark %Sock %Nick %Chan %PID $Iif($4 == DIALOG_CHECK, DIALOG_CHECK, NORMAL) $Regml(1)
    }
  }
}

on *:SOCKOPEN:PROFILE.FINAL.*: {
  if ($Sockerr) return

  tokenize 32 $Sock($Sockname).mark

  sockwrite -n $Sockname GET $5- HTTP/1.0 $+ $Crlf $+ $&
    Accept: */* $+ $Crlf $+ $&
    Accept-Language: EN-US $+ $CrLf $+ Accept-Encoding: gzip, deflate $+ $Crlf $+ $&
    User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1) $+ $Crlf $+ $&
    Host: $MainSettings(CONNECTION, WEBLINK) $+ $CrLf $+ $&
    Cookie: Cookie: lang=EN; $+ $Str($Crlf, 2)
}

on *:SOCKREAD:PROFILE.FINAL.*: {
  if ($Sockerr > 0) return

  var %Read, %Nick = $Gettok($Sock($Sockname).mark, 1, 32), %Chan = $Gettok($Sock($Sockname).mark, 2, 32), $&
    %Pid = $Gettok($Sock($Sockname).mark, 3, 32)

  sockread %Read

  ; echo -a %Read

  if (*HTTP/1.1 302 Found* iswm %Read) halt

  elseif ($Regex(%Read, img src="(.*)" alt="Personal Photo"(.*) onClick="(.*)" style="cursor:pointer;")) {
    var %_Info = $Gettok($Regml(3), 2, 39), %Link = $Iif(*../* iswm %_Info, www.buzzen.com/ $+ $Remove(%_Info, ../), %_Info)

    if ($Dialog(ProfileManager)) {
      xdid -n ProfileManager 4553 %Link
      xdid -r ProfileManager 4554
      xdid -a ProfileManager 4554 %Link
    }

    .signal -n PROFILE_KICKER NO_IMAGE %Nick %Chan $Regml(1)
  }

  elseif ($Regex(%Read, /\<strong\>Name\<\/strong\>\<br\>/)) {
    sockread %Read

    var %Name = %Read, %Sm = $Iif(%Name, $SBracks(Name: $Ifmatch), $SBracks(Name: Unset))

    if (*DIALOG_CHECK* iswm $Sock($Sockname).mark) Listview_Profile %Sm
    else {
      if ($MainSettings(PROFILE, SHOW_NAME) == 1) sockmark $Sockname $+($Sock($Sockname).mark, $Chr(32), %Sm)
    }

    .signal -n PROFILE_KICKER NAME %Nick %Chan %Name
  }

  elseif ($Regex(%Read, /\<strong\>(Location|Age|Gender|Marital Status)\<\/strong\>\<br\>/)) {
    sockread %Read

    var %Type = %Read, %Sm = $Iif(%Type, $SBracks($Regml(1) $+ : $Ifmatch), $SBracks($Regml(1) $+ : Unset))

    if (*DIALOG_CHECK* iswm $Sock($Sockname).mark) Listview_Profile %Sm
    else {
      if ($MainSettings(PROFILE, SHOW_ $+ $Replace($Regml(1), Marital Status, Marital_Status)) == 1) sockmark $Sockname $+($Sock($Sockname).mark, $Chr(32), %Sm)
    }

    .signal -n PROFILE_KICKER $Replace($Regml(1), Marital Status, Marital_Status) %Nick %Chan %Type
  }

  elseif ($Regex(%Read, /\<strong\>My website\<\/strong\>\<br\>/)) {
    sockread %Read

    var %Site = $Regex(%Read ,/\<a href=\"(.*)\"\>/), %Sm = $Iif($Regml(1), $SBracks(Homepage: $Ifmatch), $SBracks(Homepage: Unset))

    if (*DIALOG_CHECK* iswm $Sock($Sockname).mark) Listview_Profile %Sm
    else {
      if ($MainSettings(PROFILE, SHOW_HOMEPAGE) == 1) sockmark $Sockname $+($Sock($Sockname).mark, $Chr(32), %Sm) 
    }
  }

  elseif ($Regex(%Read, /alt=\"Email address\" align=\"left\"/)) {
    sockread %Read

    var %Email = $Regsubex(%Read ,/(<[^>]+>)/g, ), %Sm = $Iif(%Email, $SBracks(Email: $Ifmatch), $SBracks(Email: Unset))

    if (*DIALOG_CHECK* iswm $Sock($Sockname).mark) Listview_Profile %Sm

    if ($MainSettings(PROFILE, SHOW_EMAIL) == 0) && (*DIALOG_CHECK* !iswm $Sock($Sockname).mark) { }
    else sockmark $Sockname $Sock($Sockname).mark $+ $Chr(32) $+ %Sm

    if (*DIALOG_CHECK* !iswm $Sock($Sockname).mark) {
      if ($MainSettings(PROFILE, SHOW_URL) == 1) sockmark $Sockname $Sock($Sockname).mark $+ $Chr(32) $+ $&
        Profile link: http:// $+ $MainSettings(CONNECTION, WEBLINK) $+ $Gettok($Sock($Sockname).mark, 5, 32)

      Profile_Capture $Sockname $Sock($Sockname).mark
    }

    sockclose $Sockname

    return
  }

  :error
  if ($Error) reseterror
}

; Profile kicker

on *:SIGNAL:PROFILE_KICKER:{
  var %Type = $1, %Nick = $2, %Chan = $3, $&
    %SendKick = sockwrite -n $C_Sock(%Chan) KICK %Chan %Nick, $&
    %Clear, %Ban

  ; echo -a $1-

  if ($MainSettings(PROFILE, CLEAR_OWNER_HOST) == 1) {
    %Clear = ACCESS %Chan CLEAR OWNER $+ $Crlf $+ ACCESS %Chan CLEAR HOST
  }

  if ($MainSettings(PROFILE, BAN_USERS) == 1) {
    var %Duration = $MainSettings(PROFILE, BAN_DURATION)

    %Ban = ACCESS %Chan ADD DENY *!* $+ $Ial(%Nick).addr %Duration : $+ %Nick banned by Moschino[ProfileManager]!
  }

  if ($MainSettings(PROFILE, PERMANENT_BAN) == 1) {
    %Ban = ACCESS %Chan ADD DENY *!* $+ $Ial(%Nick).addr 0 : $+ %Nick banned by Moschino[ProfileManager]!
  }

  if (%Nick ison %Chan) && (!$MainSettings(PROFILEKICKS_HALTED, %Chan)) {
    if ($Nick(%Chan, %Nick, '.@)) && ($MainSettings(PROFILE, HALT_OPS) == 1) return

    if (%Type == NAME) {
      if ($MainSettings(PROFILE, KICK_UNDISCLOSED_NAME) == 1) && ($4 == $Chr(32) || (!$4)) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), PROFILE, UNDISCLOSED_NAME_MSG) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }
    }

    elseif (%Type == AGE) {
      if ($4 isnum) {
        if ($MainSettings(PROFILE, KICK_UNDERAGE_USERS) == 1)  && ($4 < $MainSettings(PROFILE, UNDER_AGE)) {
          %SendKick $Readini($Fp(data/GlobalSettings.ini), PROFILE, UNDER_AGE_MSG) $&
            $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
        }
      }

      else {
        if ($MainSettings(PROFILE, KICK_UNDISCLOSED_AGE) == 1) {
          %SendKick $Readini($Fp(data/GlobalSettings.ini), PROFILE, UNDISCLOSED_AGE_MSG) $&
            $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
        }
      }
    }

    elseif (%Type == LOCATION) {
      if ($MainSettings(PROFILE, KICK_UNDISCLOSED_LOCATION) == 1) && (!$4) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), PROFILE, UNDISCLOSED_LOCATION_MSG) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }
    }

    elseif (%Type == GENDER) {
      if ($4 == Undisclosed) && ($MainSettings(PROFILE, KICK_UNDISCLOSED_GENDER) == 1) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), PROFILE, UNDISCLOSED_GENDER_MSG) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }

      elseif ($4 == Male) && ($MainSettings(PROFILE, KICK_MALES) == 1) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), PROFILE, KICK_MALES_MSG) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }

      elseif ($4 == Female) && ($MainSettings(PROFILE, KICK_FEMALES) == 1) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), PROFILE, KICK_FEMALES_MSG) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }
    }

    elseif (%Type == NO_IMAGE) {
      if ($MainSettings(PROFILE, KICK_NO_IMAGE) == 1) && ($4 == www.buzzen.com/inc/image/no_picture.jpg) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), PROFILE, NO_IMAGE_MSG) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }
    }
  }
}

menu nicklist {
   :halt
   Profile Scan Check 
  .-
  .Multi-select profile(s) check: MultiProfileCheck # $1-
}
