; Moschino's script detector designed to work with only the Moschino[FlashBuzzen] connection.
; Note that this mIRC detector is a basic one, and still easy to bypass by the average mIRC scripter.
; -
; Please visit http://moschino.org.uk for updates/problems/suggesstions.
; Thanks, Dabba.


on *:START: {
  if ($Con_Version < 2.37) {
    echo -sace info *** Moschino[ScriptDetector] will only work correctly on connection version 2.37 (onwards). $&
      Please update your Moschino[FlashBuzzen] connection.
  }

  if (!$Item_Exists(SCRIPT_DETECTOR, CHECK_INVALID_TIME_REPLY)) MainSettings SCRIPT_DETECTOR CHECK_INVALID_TIME_REPLY 0
  if (!$Item_Exists(SCRIPT_DETECTOR, CHECK_CONNECTION_TAGS)) MainSettings SCRIPT_DETECTOR CHECK_CONNECTION_TAGS 0
  if (!$Item_Exists(SCRIPT_DETECTOR, CHECK_NOTIME_REPLY)) MainSettings SCRIPT_DETECTOR CHECK_NOTIME_REPLY 0
  if (!$Item_Exists(SCRIPT_DETECTOR, CHECK_WEBCHAT_REPLY)) MainSettings SCRIPT_DETECTOR CHECK_WEBCHAT_REPLY 0

  if (!$Item_Exists(SCRIPT_DETECTOR, KICK)) MainSettings SCRIPT_DETECTOR KICK 0
  if (!$Item_Exists(SCRIPT_DETECTOR, MSG)) MainSettings SCRIPT_DETECTOR MSG 1
  if (!$Item_Exists(SCRIPT_DETECTOR, ECHO)) MainSettings SCRIPT_DETECTOR ECHO 0

  if (!$Item_Exists(SCRIPT_DETECTOR, INVALID_TIME_REPLY)) MainSettings SCRIPT_DETECTOR INVALID_TIME_REPLY $(%Nick $+ ! Your time reply is invalid .. bad script! :@, )
  if (!$Item_Exists(SCRIPT_DETECTOR, CONNECTION_TAG)) MainSettings SCRIPT_DETECTOR CONNECTION_TAG $(Sorry %Nick $+ , you have a non-webchat tag!, ) 
  if (!$Item_Exists(SCRIPT_DETECTOR, TIME_REPLY_WAIT)) MainSettings SCRIPT_DETECTOR TIME_REPLY_WAIT 12
  if (!$Item_Exists(SCRIPT_DETECTOR, NOTIME_REPLY)) MainSettings SCRIPT_DETECTOR NOTIME_REPLY $(You didn't have a time reply, are you a bot? :@, )
  if (!$Item_Exists(SCRIPT_DETECTOR, NOWEBCHAT_REPLY)) MainSettings SCRIPT_DETECTOR NOWEBCHAT_REPLY $(No webchat reply? GET OUT BOT!!!!!!!!!, )

  if (!$Item_Exists(SCRIPT_DETECTOR, HALT_OPS)) MainSettings SCRIPT_DETECTOR HALT_OPS 1
  if (!$Item_Exists(SCRIPT_DETECTOR, BAN_USERS)) MainSettings SCRIPT_DETECTOR BAN_USERS 0
  if (!$Item_Exists(SCRIPT_DETECTOR, BAN_DURATION)) MainSettings SCRIPT_DETECTOR BAN_DURATION 6
  if (!$Item_Exists(SCRIPT_DETECTOR, PERMANENT_BAN)) MainSettings SCRIPT_DETECTOR PERMANENT_BAN 0
  if (!$Item_Exists(SCRIPT_DETECTOR, CLEAR_OWNER_HOST)) MainSettings SCRIPT_DETECTOR CLEAR_OWNER_HOST 0
}

dialog ScriptDetector {
  title "Moschino[ScriptDetector]1.3"
  size -1 -1 176 265
  option dbu
}

on *:DIALOG:ScriptDetector:INIT:0:{
  var %D = $Dname

  dcx Mark %D Bot_Detector_Callback

  ; Border.
  xdialog -b %D +woty

  xdialog -c %D 45 box 3 115 348 44
  xdid -t %D 45 Script/bot alert method

  xdid -c %D 45 1 check 5 18 100 15
  xdid -t %D 1 Kick script users
  if ($MainSettings(SCRIPT_DETECTOR, KICK) == 1) xdid -c %D 1
  xdid -c %D 45 2 check 134 18 90 15
  xdid -t %D 2 Message room
  if ($MainSettings(SCRIPT_DETECTOR, MSG) == 1) xdid -c %D 2
  xdid -c %D 45 3 check 258 18 80 15
  xdid -t %D 3 Echo in room
  if ($MainSettings(SCRIPT_DETECTOR, ECHO) == 1) xdid -c %D 3

  xdialog -c %D 46 listview 2 3 349 108 report grid borderselect flatsb fullrow checkbox
  xdid -t %D 46 +l 0 350 Onjoin script detection types
  xdid -a %D 46 0 0 + 0 $Iif($MainSettings(SCRIPT_DETECTOR, CHECK_INVALID_TIME_REPLY) == 1, 2, 1) 0 0 0 0 Check for invalid time replies 
  xdid -a %D 46 0 0 + 0 $Iif($MainSettings(SCRIPT_DETECTOR, CHECK_CONNECTION_TAGS) == 1, 2, 1) 0 0 0 0 Check connection tags via //WHO
  xdid -a %D 46 0 0 + 0 $Iif($MainSettings(SCRIPT_DETECTOR, CHECK_NOTIME_REPLY) == 1, 2, 1) 0 0 0 0 Check for no time reply
  xdid -a %D 46 0 0 + 0 $Iif($MainSettings(SCRIPT_DETECTOR, CHECK_WEBCHAT_REPLY) == 1, 2, 1) 0 0 0 0 Check for no webchat reply

  xdialog -c %D 47 box 3 164 348 219
  xdid -t %D 47 Kick messages

  xdid -c %D 47 98 text 7 18 147 15
  xdid -t %D 98 Invalid time reply:
  xdid -c %D 47 99 edit 6 34 337 22 autohs
  xdid -a %D 99 $Readini($Fp(data/GlobalSettings.ini), n, SCRIPT_DETECTOR, INVALID_TIME_REPLY)

  xdid -c %D 47 102 text 7 62 147 15 
  xdid -t %D 102 Connection tags:
  xdid -c %D 47 103 edit 6 77 337 22 autohs
  xdid -a %D 103 $Readini($Fp(data/GlobalSettings.ini), n, SCRIPT_DETECTOR, CONNECTION_TAG)

  ; For users on previous versions of the script detector
  if ($MainSettings(SCRIPT_DETECTOR, TIME_REPLY_WAIT) < 12) MainSettings SCRIPT_DETECTOR TIME_REPLY_WAIT 12

  xdid -c %D 47 565 text 6 111 185 15
  xdid -t %D 565 Time to wait for time/webchat replies:
  xdid -c %D 47 876 edit 191 108 40 22
  xdid -c %D 47 866 updown 263 180 80 20 buddyint
  xdid -r %D 866 12 60
  xdid -c %D 866 876
  xdid -v %D 866 $MainSettings(SCRIPT_DETECTOR, TIME_REPLY_WAIT)
  xdid -c %D 47 896 text 235 111 50 18
  xdid -t %D 896 (seconds)
  xdid -c %D 47 6867 button 296 109 30 23
  xdid -l %D 6867 16
  xdid -w %D 6867 +n 0 $MircdirIcons/info.ico

  xdid -c %D 47 947 text 7 132 100 15 autohs
  xdid -t %D 947 No time reply:
  xdid -c %D 47 948 edit 6 147 337 22 autohs
  xdid -a %D 948 $Readini($Fp(data/GlobalSettings.ini), n, SCRIPT_DETECTOR, NOTIME_REPLY)

  xdid -c %D 47 949 text 7 176 100 15 autohs
  xdid -t %D 949 No webchat reply:
  xdid -c %D 47 950 edit 6 191 337 22 autohs
  xdid -a %D 950 $Readini($Fp(data/GlobalSettings.ini), n, SCRIPT_DETECTOR, NOWEBCHAT_REPLY)

  ; Box control.
  xdialog -c %D 7364 box 2 388 348 114
  xdid -t %D 7364 Script detecting channel halting

  xdid -c %D 7364 35 check 6 18 145 15
  xdid -t %D 35 Halt kicks on owners/hosts
  if ($MainSettings(SCRIPT_DETECTOR, HALT_OPS) == 1) xdid -c %D 35
  xdid -c %D 7364 135 check 171 18 173 15
  xdid -t %D 135 Clear owner/host access on kick
  if ($MainSettings(SCRIPT_DETECTOR, CLEAR_OWNER_HOST) == 1) xdid -c %D 135
  xdid -c %D 7364 36 check 6 38 83 15
  xdid -t %D 36 Ban users for
  if ($MainSettings(SCRIPT_DETECTOR, BAN_USERS) == 1) xdid -c %D 36
  xdid -c %D 7364 836 edit 92 35 40 22
  xdid -c %D 7364 846 updown 180 70 80 20 buddyint
  xdid -r %D 846 1 30
  xdid -c %D 846 836
  xdid -v %D 846 $MainSettings(SCRIPT_DETECTOR, BAN_DURATION)
  xdid -c %D 7364 1896 text 136 38 40 18 
  xdid -t %D 1896 (mins)
  if ($MainSettings(SCRIPT_DETECTOR, BAN_USERS) == 0) xdid -b %D 836,846

  xdid -c %D 7364 446 check 171 38 90 15
  xdid -t %D 446 Permanent ban
  if ($MainSettings(SCRIPT_DETECTOR, PERMANENT_BAN) == 1) xdid -c %D 446

  xdid -c %D 7364 736 comboex 6 60 249 138 dropdown

  var %x 1
  while (%x <= $Chan(0)) {
    xdid -a %D 736 0 0 0 0 0 $Chan(%x)

    inc %x
  }
  xdid -c %D 736 2

  xdid -c %D 7364 8458 button 258 60 84 22
  xdid -t %D 8458 Halt channel

  xdid -c %D 7364 263 text 7 90 80 22
  xdid -t %D 263 Halted channels:
  xdid -c %D 7364 921 comboex 91 85 164 138 dropdown
  xdid -c %D 7364 8468 button 258 85 84 22
  xdid -t %D 8468 Unhalt channel

  ; Link.
  xdialog -c %D 19 text 3 511 135 23
  xdid -t %D 19 $MainSettings(CONNECTION, LINK)
  xdid -f %D 19 +au ansi 8 Verdana
  xdid -C %D 19 +t $Rgb(0, 0, 255)

  ; Button.
  xdialog -c %D 48 button 186 506 100 25
  xdid -w %D 48 +n 0 Icons/Settings.ico
  xdid -t %D 48 View safe list

  ; Button.
  xdialog -c %D 44 button 290 506 60 25
  xdid -w %D 44 +n 0 Icons/Settings.ico
  xdid -t %D 44 Ok

  if ($MainSettings(SCRIPT_DETECTOR, KICK) == 0) xdid -b %D 99,103,948,950

  ; Font.
  xdid -f %D 45,1,2,3,46,47,98,99,102,103,565,876,896,947,948,949,950,7364,35,36,836,1896,736,8458,263,921,8468,44,48,135 +a ansi 8 Tahoma

  List_ScriptKicks_Halted_Channels
}

; Do _NOT_ remove or edit this line. The version checker uses it.
alias mIRCDetector_Version return 1.3

alias Bot_Detector_Callback {
  ; echo -a $1-

  if ($2 == SCLICK) {
    ;echo -a $1-

    if ($3 == 19) RUN $xdid($1, 19).text

    elseif ($3 == 44) dialog -x $1

    elseif ($3 == 48) run $Fp(data/ScriptKickSafeList.ini)

    elseif ($3 == 8458) {
      MainSettings SCRIPTKICKS_HALTED $xdid($1, 736).seltext HALTED

      List_ScriptKicks_Halted_Channels
    }

    elseif ($3 == 8468) {
      RemSettings SCRIPTKICKS_HALTED $xdid($1, 921).seltext

      List_ScriptKicks_Halted_Channels
    }

    elseif ($3 == 6867) {
      $Input(If you find your script detector is detecting legit webchat users as mIRC $+ $Chr(44) $&
        then play around with this time variable. $+ $Str($Crlf, 2) $+ It's possible for some users to take more than 12 seconds to reply $+ $Chr(44) $&
        due to things like PC or server laggyness., oi, Webchat/time replies)
    }
  }

  elseif ($2 == STATECLICK) && ($3 == 46) {
    if ($4 == 1) {
      var %State = $xdid($1, 46, $4).state

      if (%State == 1) MainSettings SCRIPT_DETECTOR CHECK_INVALID_TIME_REPLY 1
      else MainSettings SCRIPT_DETECTOR CHECK_INVALID_TIME_REPLY 0
    }

    elseif ($4 == 2) {
      var %State = $xdid($1, 46, $4).state

      if (%State == 1) MainSettings SCRIPT_DETECTOR CHECK_CONNECTION_TAGS 1
      else MainSettings SCRIPT_DETECTOR CHECK_CONNECTION_TAGS 0
    }

    elseif ($4 == 3) {
      var %State = $xdid($1, 46, $4).state

      if (%State == 1) MainSettings SCRIPT_DETECTOR CHECK_NOTIME_REPLY 1
      else MainSettings SCRIPT_DETECTOR CHECK_NOTIME_REPLY 0
    }

    elseif ($4 == 4) {
      var %State = $xdid($1, 46, $4).state

      if (%State == 1) MainSettings SCRIPT_DETECTOR CHECK_WEBCHAT_REPLY 1
      else MainSettings SCRIPT_DETECTOR CHECK_WEBCHAT_REPLY 0
    }
  }

  elseif ($2 == LBDOWN) {
    ;echo -a $1-

    if ($3 == 1) {
      var %State = $xdid($1, $3).state

      MainSettings SCRIPT_DETECTOR KICK $Iif(%State == 0, 1, 0)

      if (%State == 0) xdid -e $1 99,103,948,950
      elseif (%State == 1) xdid -b $1 99,103,948,950
    }

    elseif ($3 == 2) {
      var %State = $xdid($1, $3).state

      MainSettings SCRIPT_DETECTOR MSG $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 3) {
      var %State = $xdid($1, $3).state

      MainSettings SCRIPT_DETECTOR ECHO $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 35) {
      var %State = $xdid($1, $3).state

      MainSettings SCRIPT_DETECTOR HALT_OPS $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 135) {
      var %State = $xdid($1, $3).state

      MainSettings SCRIPT_DETECTOR CLEAR_OWNER_HOST $Iif(%State == 0, 1, 0)
    }

    elseif ($3 == 36) {
      var %State = $xdid($1, $3).state

      if (%State == 0) {
        MainSettings SCRIPT_DETECTOR BAN_USERS 1
        xdid -e $1 836,846
      }

      elseif (%State == 1) {
        MainSettings SCRIPT_DETECTOR BAN_USERS 0
        xdid -b $1 836,846
      }
    }

    elseif ($3 == 446) {
      var %State = $xdid($1, $3).state

      MainSettings SCRIPT_DETECTOR PERMANENT_BAN $Iif(%State == 0, 1, 0)
    }
  }

  elseif ($2 == KEYUP) {
    var %File = $Fp(data\GlobalSettings.ini)

    if ($3 == 99) writeini -n %File SCRIPT_DETECTOR INVALID_TIME_REPLY $xdid($1, 99).text
    elseif ($3 == 101) writeini -n %File SCRIPT_DETECTOR MOSCHINO_VERSION $xdid($1, 101).text
    elseif ($3 == 103) writeini -n %File SCRIPT_DETECTOR CONNECTION_TAG $xdid($1, 103).text
    elseif ($3 == 948) writeini -n %File SCRIPT_DETECTOR NOTIME_REPLY $xdid($1, 948).text
    elseif ($3 == 950) writeini -n %File SCRIPT_DETECTOR NOWEBCHAT_REPLY $xdid($1, 950).text
  }

  elseif ($2 == MOUSE) {
    if ($3 == 866) || ($3 == 876) {
      MainSettings SCRIPT_DETECTOR TIME_REPLY_WAIT $xdid($1, 866).value
    }

    elseif ($3 == 836) || ($3 == 846) {
      MainSettings SCRIPT_DETECTOR BAN_DURATION $xdid($1, 846).value
    }
  }
}

alias List_ScriptKicks_Halted_Channels {
  var %File = $Fp(data/GlobalSettings.ini), %Section = SCRIPTKICKS_HALTED, %x 1

  xdid -r ScriptDetector 921

  while (%x <= $Ini(%File, %Section, 0)) {
    xdid -a ScriptDetector 921 0 0 0 0 0 $Ini(%File, %Section, %x)

    inc %x
  }

  xdid -c ScriptDetector 921 1
}

alias Alert_Type {
  if ($MainSettings(SCRIPT_DETECTOR, ECHO) == 1) echo -e $1-

  if ($MainSettings(SCRIPT_DETECTOR, MSG) == 1) msg $1-
}

on ^!*:JOIN:#: {
  if (!$MainSettings(SCRIPTKICKS_HALTED, #)) && (*MCHAN* !iswm $Server) {
    var %Sw = sockwrite -n $C_Sock(#)

    if ($MainSettings(SCRIPT_DETECTOR, CHECK_INVALID_TIME_REPLY) == 1) {
      que 1000 %Sw PRIVMSG $Chr(37) $!+ $Mid(#, 2) $Nick $+($Chr(1), TIME, $Chr(1))

      if ($MainSettings(SCRIPT_DETECTOR, CHECK_NOTIME_REPLY) == 1) {
        if ($Timer(WT $+ $Nick $+ #)) .timerWT $+ $Nick $+ # off

        .timerWT $+ $Nick $+ # 1 $MainSettings(SCRIPT_DETECTOR, TIME_REPLY_WAIT) No_Time_Reply $Nick $Mid(#, 2)
      }
    }

    if ($MainSettings(SCRIPT_DETECTOR, CHECK_CONNECTION_TAGS) == 1) {
      hadd -m SCRIPT_CHECK. $+ # # $Hget(SCRIPT_CHECK. $+ #, #) $Nick

      que 1000 %Sw WHO $Chr(37) $!+ $Mid(#, 2)
    }

    if ($MainSettings(SCRIPT_DETECTOR, CHECK_WEBCHAT_REPLY) == 1) {
      hadd -m SCRIPT_CHECK. $+ # # $Hget(SCRIPT_CHECK. $+ #, #) $Nick

      if ($Is_Guest($Nick)) return

      que 1000 %Sw PRIVMSG $Chr(37) $!+ $Mid(#, 2) $+(:, $Chr(1), VERSION Moschino[FlashBuzzen], $Chr(1), $Chr(15))

      .timerCT $+ $Nick $+ # 1 $MainSettings(SCRIPT_DETECTOR, TIME_REPLY_WAIT) No_WebchatClient_Reply $Nick $Mid(#, 2)
    }
  }
}

on ^*:NOTICE:*:#: {
  tokenize 32 $Rawmsg

  var %Nick = $Mid($Gettok($1, 1, 33), 3)

  if ($+(*, $Chr(2), TIME, $Chr(2), *) iswm $1-) {
    var %Reply = $Mid($6-, 8)

    if ($Timer(WT $+ %Nick $+ #)) .timerWT $+ %Nick $+ # off

    if (!$Regex(%Reply, /^([A-Z][a-z]{2}) (?1) (\d{1,2}) (\d{2}:\d{2}:\d{2}) (GMT(\-|\+)\d{4}) $Asctime(yyyy)$/)) {
      if ($MainSettings(SCRIPT_DETECTOR, KICK) != 1) {
        que 1000 Alert_Type $Chr(37) $!+ $Mid($3, 2) * Possible mIRC user: %Nick [No valid time reply]

        if ($Timer(WT $+ %Nick $+ $3)) .timerWT $+ %Nick $+ $3 off
        if ($Timer(CT $+ %Nick $+ $3)) .timerCT $+ %Nick $+ $3 off
      }

      .signal -n SCRIPT_KICKER INVALID_TIME_REPLY %Nick #
    }
  }

  if (*VERSION* iswm $6) {
    if (*Ajax IRCwx Client 1.0 beta 1,* iswm $1-) {
      if ($Timer(CT $+ %Nick $+ #)) .timerCT $+ %Nick $+ # off
    }
  }
}

alias No_Time_Reply {
  var %Nick = $$1, %Chan = $+($(%, ), $$2)

  if ($Nick(%Chan, %Nick)) {
    if ($MainSettings(SCRIPT_DETECTOR, KICK) != 1) {
      que 1000 Alert_Type $Chr(37) $!+ $Mid(%Chan, 2) * Possible mIRC user: %Nick [No valid time reply]

      if ($Timer(CT $+ %Nick $+ %Chan)) .timerCT $+ %Nick $+ %Chan off
    }

    .signal -n SCRIPT_KICKER NO_TIME_REPLY %Nick %Chan
  }
}

raw 352:*: {
  if ($Istok($Hget(SCRIPT_CHECK. $+ $2, $2), $6, 32)) {
    if (!$9) || ($9 != anon) {
      if ($MainSettings(SCRIPT_DETECTOR, KICK) != 1) {
        que 1000 Alert_Type $!Chr(37) $!+ $Mid($2, 2) * Possible mIRC user: $6 [Non-webchat tag]

        if ($Timer(WT $+ $6 $+ $2)) .timerWT $+ $6 $+ $2 off
        if ($Timer(CT $+ $6 $+ $2)) .timerCT $+ $6 $+ $2 off
      }

      .signal -n SCRIPT_KICKER NON_WEBCHAT_TAG $6 $2
    }
  }
}

raw 315:*: {
  if ($Hget(SCRIPT_CHECK. $+ $2, $2)) hfree SCRIPT_CHECK. $+ $2
}

alias No_WebchatClient_Reply {
  var %Nick = $$1, %Chan = $+($(%, ), $$2)

  que 1000 Alert_Type $Chr(37) $!+ $Mid(%Chan, 2) * Possible mIRC user: %Nick [No valid webchat reply]

  if ($Timer(WT $+ %Nick $+ %Chan)) .timerWT $+ %Nick $+ %Chan off

  .signal -n SCRIPT_KICKER NO_WEBCHAT_REPLY %Nick %Chan
}

on *:PART:#: {
  if ($Timer(WT $+ $Nick $+ #)) .timerWT $+ $Nick $+ # off
  if ($Timer(CT $+ $Nick $+ #)) .timerCT $+ $Nick $+ # off
}

on *:KICK:#: {
  var %Nick = $Knick

  if ($Timer(WT $+ %Nick $+ #)) .timerWT $+ %Nick $+ # off
  if ($Timer(CT $+ %Nick $+ #)) .timerCT $+ %Nick $+ # off
}

on *:SIGNAL:SCRIPT_KICKER:{
  if ($MainSettings(SCRIPT_DETECTOR, KICK) == 1) {
    var %Type = $1, %Nick = $2, %Chan = $3, $&
      %SendKick = sockwrite -n $C_Sock(%Chan) KICK %Chan %Nick, $&
      %Clear, %Ban

    if ($Is_User_Safe($Ial(%Nick).addr)) {
      echo -e # * %Nick has been detected as a mIRC script user, but they are on your script kick safe list, so they will not be kicked!

      return
    }

    if ($MainSettings(SCRIPT_DETECTOR, CLEAR_OWNER_HOST) == 1) {
      %Clear = ACCESS %Chan CLEAR OWNER $+ $Crlf $+ ACCESS %Chan CLEAR HOST
    }

    if ($MainSettings(SCRIPT_DETECTOR, BAN_USERS) == 1) {
      var %Duration = $MainSettings(SCRIPT_DETECTOR, BAN_DURATION)

      %Ban = ACCESS %Chan ADD DENY *!* $+ $Ial(%Nick).addr %Duration : $+ %Nick banned by Moschino[ScriptDetector]!
    }

    if ($MainSettings(SCRIPT_DETECTOR, PERMANENT_BAN) == 1) {
      %Ban = ACCESS %Chan ADD DENY *!* $+ $Ial(%Nick).addr 0 : $+ %Nick banned by Moschino[ScriptDetector]!
    }

    if (%Nick ison %Chan) && (!$MainSettings(SCRIPTKICKS_HALTED, %Chan)) {
      if ($Nick(%Chan, %Nick, '.@)) && ($MainSettings(SCRIPT_DETECTOR, HALT_OPS) == 1) return

      if (%Type == INVALID_TIME_REPLY) {
        %SendKick $Readini($Mircdirdata/GlobalSettings.ini, SCRIPT_DETECTOR, INVALID_TIME_REPLY) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }

      elseif (%Type == NON_WEBCHAT_TAG) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), SCRIPT_DETECTOR, CONNECTION_TAG) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }

      elseif (%Type == NO_TIME_REPLY) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), SCRIPT_DETECTOR, NOTIME_REPLY) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }

      elseif (%Type == NO_WEBCHAT_REPLY) {
        %SendKick $Readini($Fp(data/GlobalSettings.ini), SCRIPT_DETECTOR, NOWEBCHAT_REPLY) $&
          $Iif(%Clear, $+ $Crlf $+ %Clear) $Iif(%Ban, $+ $Crlf $+ %Ban)
      }
    }
  }
}

alias Is_User_Safe {
  var %Ial = $$1

  if (%Ial) && ($Readini($Fp(data/ScriptKickSafeList.ini), SAFE_LIST, %Ial)) return $True

  else return $False
}

alias Script_Safe_List {
  var %Nick = $$2, %Ial = $Ial(%Nick).addr

  if (!%Ial) {
    echo -ae # * mIRC doesn't seem to have the IAL stored for %Nick, //who'ing the channel.. please try again.
    sockwrite -n $C_Sock(#) WHO #

    return
  }

  if ($1 == ADD) {
    writeini $Fp(data/ScriptKickSafeList.ini) SAFE_LIST %Ial %Nick (Protected from script detector kicks)

    echo -ae * Added %Nick to the script kick safe list. If %Nick is detected as a script and your $&
      script kicker is ON, they will NOT be kicked.
  }

  elseif ($1 == REMOVE) {
    remini $Fp(data/ScriptKickSafeList.ini) SAFE_LIST %Ial

    echo -ae * Removed %Nick from the script kick safe list. Note that if %Nick is detected as a script and your $&
      script kicker is ON, they WILL be kicked.
  }
}

menu nicklist {
   :halt
   Script kick safe list 
  . $+ $Iif($Is_User_Safe($Ial($$1).addr), $Style(2)) Add user: Script_Safe_List ADD $$1
  . $+ $Iif(!$Is_User_Safe($Ial($$1).addr), $Style(2)) Remove user: Script_Safe_List REMOVE $$1
}
